using System;
using MVR.FileManagementSecure;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using SimpleJSON;

namespace NeMech 
{
    public class NeMechGameSave: MVRScript
    {

		private SaveData Sd = new SaveData();
		private SaveData Sdcurrent;

		const string SavePath = "Saves/PluginData/NemechGameSaves/";
		const string SaveFile = "S016.save";


		private int gameEvent;

		protected UIDynamicButton dbutton;
		protected JSONStorableAction manualSwTrigger;
		CollisionTrigger executeTrigger;


        public override void Init()
        {
			CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
			JSONClass trigClass = executeTrigger.trigger.GetJSON();
			JSONArray trigArray = trigClass["startActions"].AsArray;
			trigArray[0]["enabled"].Value = "true";		// 0: PersonTalk Move
			trigArray[1]["enabled"].Value = "false";		// 1: GabrielTalk not use in S016
			trigArray[2]["enabled"].Value = "true";		// 2: PersonTL text
			trigArray[3]["enabled"].Value = "true";		// 3: Orgasm : Call From MAMMoan
			trigArray[4]["enabled"].Value = "true";		// 4: appendex in S016 not use
			executeTrigger.trigger.RestoreFromJSON(trigClass);

            try
            {
				manualSwTrigger = new JSONStorableAction("seanEvant",ActionButtonCallback);
				RegisterAction(manualSwTrigger);
				dbutton = CreateButton("seanEvant",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener(ActionButtonCallback);
				}

				manualSwTrigger = new JSONStorableAction("seanEvant2",seanEvant2Callback);
				RegisterAction(manualSwTrigger);
				dbutton = CreateButton("seanEvant2",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener(seanEvant2Callback);
				}



 
				manualSwTrigger = new JSONStorableAction("personTalk",personTalkCallback);
				RegisterAction(manualSwTrigger);
				dbutton = CreateButton("personTalk",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener(personTalkCallback);
				}

				manualSwTrigger = new JSONStorableAction("OrgasmCount",()=>
				{
					Sd.thisOrgasmCount ++;
				});
				RegisterAction(manualSwTrigger);
				dbutton = CreateButton("OrgasmCount",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener( () =>
					{
						Sd.thisOrgasmCount ++;
					});
				}

				manualSwTrigger = new JSONStorableAction("Orgasm",()=>
				{
					executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
					executeTrigger.trigger.active = true;
					executeTrigger.trigger.active = false;		
				});
				RegisterAction(manualSwTrigger);
				dbutton = CreateButton("Orgasm",false);
				if (dbutton != null) {
					dbutton.button.onClick.AddListener( () =>
					{
						executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
						executeTrigger.trigger.active = true;
						executeTrigger.trigger.active = false;		
					});
				}




				// JSONStorableString
				pluginInfo = new JSONStorableString("pluginInfo", "" );
				dtext = CreateTextField(pluginInfo,true);
				dtext.height=30f;
			}
			catch (Exception e)
			{
    	    	SuperController.LogError("Exception caught: " + e);
	        }
		}
		private UIDynamicTextField dtext;
		private JSONStorableString pluginInfo;

		TimeSpan timed ;


		void  Start() {
			string thisBoot;
			thisBoot = DateTime.Now.ToString();




			gameLoad();
			statisProcess();
			if( Sd.startCount == 1){
				// 1st play
				gameEvent = 1;
				Sd.FirstBoot = thisBoot;
//				Sd.lastBoot = thisBoot - new TimeSpan(1,0,0);
				Sd.lastBoot = (DateTime.Now.AddDays(-2)).ToString();
				Sd.favRate ++;

			} else {

				try
				{
					timed = DateTime.Now - DateTime.Parse(Sd.lastBoot);
				}
				catch (Exception e)
				{
//    		    	SuperController.LogError("Exception caught: " + e);
					gameEvent = 1001;	// data broken
					if(Sd.debugMode == false )
						Sd.favRate = Sd.favRate == 0 ? 0 : Sd.favRate - 1 ;
					Sd.lastBoot = thisBoot; // recover
	    	    }
	    	    

				timed = DateTime.Now - DateTime.Parse(Sd.lastBoot);
				while(true){

					if(gameEvent == 1001) break;
				
					if( timed < new TimeSpan(2,0,0) ){ // 2h
						gameEvent = 1002; // ShortBlankTime  Can't Game
						thisBoot = Sd.lastBoot;
						if(Sd.debugMode == false )
							Sd.favRate = Sd.favRate == 0 ? 0 : Sd.favRate - 1 ;
						break;
					};
				
					if( timed < new TimeSpan(12,0,0)){ // 12h
						gameEvent = 1003; // ShortBlankTime  Can't Game
						thisBoot = Sd.lastBoot;
						if(Sd.debugMode == false )
							Sd.favRate = Sd.favRate == 0 ? 0 : Sd.favRate - 1 ;

						break;
					};

					if( timed < new TimeSpan(48,0,0)){ // 48h
						gameEvent = 2;
						thisBoot = Sd.lastBoot;
						Sd.favRate += 2;;
						break;
					};


					if( timed < new TimeSpan(168,0,0)){ // 1 week
						gameEvent = 3;
						Sd.favRate += 1;
						break;
					};
				
					gameEvent = 4; // ShortBlankTime  Can't Game
					break; 
				}
				Sd.lastBoot = thisBoot;





			}
			gameSave();
			InvokeRepeating("gameSave",120f,120f);

		}
		
		void statisProcess(){

			Sd.id = SaveFile;		// いるか？
			Sd.startCount ++;
			Sd.totalPlaytime += Sd.thisPlaytime;
			Sd.thisPlaytime = 0;
			
			Sd.totalOrgasmCount += Sd.thisOrgasmCount;
			Sd.maximumOrgasmCount = ( Sd.maximumOrgasmCount > Sd.thisOrgasmCount) ?  Sd.maximumOrgasmCount : Sd.thisOrgasmCount ;
			Sd.thisOrgasmCount = 0;

		}


		void seanEvant2Callback(){
				CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
				JSONClass trigClass = executeTrigger.trigger.GetJSON();
				JSONArray trigArray = trigClass["startActions"].AsArray;
// 0: PersonTalk Move
// 1: GabrielTalk not use in S016
// 2: PersonTL text
// 3: Orgasm : Call From MAMMoan
// 4: Sex


				if(gameEvent > 1000){
					trigArray[4]["receiverTargetName"].Value = "Play needRest";
				} else {


				switch(Sd.favRate){

					case -1 :
						trigArray[4]["receiverTargetName"].Value = "Play xL0SexScene";
						break ;
					case 0 :
						trigArray[4]["receiverTargetName"].Value = "Play xL0SexScene";
						break ;
					case 1 :
						trigArray[4]["receiverTargetName"].Value = "Play xL1SexScene";
						break ;
					case 2 :
						trigArray[4]["receiverTargetName"].Value = "Play xL2SexScene";
						break ;
					case 3 :
						trigArray[4]["receiverTargetName"].Value = "Play xL3SexScene";
						break ;
					case 4 :
						trigArray[4]["receiverTargetName"].Value = "Play xL4SexScene";
						break ;
					case 5 :
						trigArray[4]["receiverTargetName"].Value = "Play xL5SexScene";
						break ;
					case 6 :
						trigArray[4]["receiverTargetName"].Value = "Play xL5SexScene";
						break ;

					default :
						trigArray[4]["receiverTargetName"].Value = "Play xL6SexScene";
						break ;

				}
				
				}
				executeTrigger.trigger.RestoreFromJSON(trigClass);
//Mask trigger
				var maskMomanSTr = trigArray[3]["receiverTargetName"].Value;
				trigArray[3]["receiverTargetName"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);


				executeTrigger.trigger.active = true;
				executeTrigger.trigger.active = false;		

//Recover trigger
				trigArray[3]["receiverTargetName"].Value = maskMomanSTr;
				trigArray[4]["receiverTargetName"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);
				
		}




		// PlayButton
		void ActionButtonCallback(){
				CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
				JSONClass trigClass = executeTrigger.trigger.GetJSON();
				JSONArray trigArray = trigClass["startActions"].AsArray;
// 0: PersonTalk Move
// 1: GabrielTalk not use in S016
// 2: PersonTL text
// 3: Orgasm : Call From MAMMoan
// 4: Sex


				if(gameEvent > 1000){
					trigArray[2]["receiverTargetName"].Value = "Play needRest";
					trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
				} else {


				switch(Sd.favRate){

					case -1 :
						trigArray[2]["receiverTargetName"].Value = "Play xL0";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";

						break ;

					case 0 :
						trigArray[2]["receiverTargetName"].Value = "Play xL0";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;
					case 1 :
						trigArray[2]["receiverTargetName"].Value = "Play xL1";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;
					case 2 :
						trigArray[2]["receiverTargetName"].Value = "Play xL2";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;
					case 3 :
						trigArray[2]["receiverTargetName"].Value = "Play xL3";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;
					case 4 :
						trigArray[2]["receiverTargetName"].Value = "Play xL4";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;
					case 5 :
						trigArray[2]["receiverTargetName"].Value = "Play xL5";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;
					case 6 :
						trigArray[2]["receiverTargetName"].Value = "Play xL6";
						trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
						break ;

					default :
						int Randmize = (int) UnityEngine.Random.Range(0, 5)+1;
						switch(Randmize){

							case 1 :
								trigArray[2]["receiverTargetName"].Value = "Play xL1";
								trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
								break ;
							case 2 :
								trigArray[2]["receiverTargetName"].Value = "Play xL2";
								trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
								break ;
							case 3 :
								trigArray[2]["receiverTargetName"].Value = "Play xL3";
								trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
								break ;
							case 4 :
								trigArray[2]["receiverTargetName"].Value = "Play xL4";
								trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";
								break ;
							case 5 :
								trigArray[2]["receiverTargetName"].Value = "Play xL5";
								trigArray[3]["receiverTargetName"].Value = trigArray[2]["receiverTargetName"].Value + "Orgasm";

								break ;
						} 
						break ;
					}
				}
				executeTrigger.trigger.RestoreFromJSON(trigClass);

//Mask trigger
				var maskMomanSTr = trigArray[3]["receiverTargetName"].Value;
				trigArray[3]["receiverTargetName"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);


				executeTrigger.trigger.active = true;
				executeTrigger.trigger.active = false;		

//Recover trigger
				trigArray[3]["receiverTargetName"].Value = maskMomanSTr;
				trigArray[2]["receiverTargetName"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);
				
		}








		void personTalkCallback(){
			CollisionTrigger executeTrigger = containingAtom.GetStorableByID("CollisionTrigger") as CollisionTrigger;
			JSONClass trigClass = executeTrigger.trigger.GetJSON();
			JSONArray trigArray = trigClass["startActions"].AsArray;
// 
// PersonTalk : 0


			if(gameEvent > 1000 ){ // NG
				switch(gameEvent){
					case 1001: trigArray[0]["stringValue"].Value = "I hate to say it, but your save data is corrupted. I've restored it, but I can't play anymore today."; break;
					case 1002:
						if(Sd.favRate<4) {
							 trigArray[0]["stringValue"].Value = "It's been less than two hours since you played with me. Are you trying to kill me?"; break;
						} else {
							 trigArray[0]["stringValue"].Value = "It's been less than two hours since I played with you, I'm sorry, I need to rest."; break;
						}
					case 1003:
						if( Sd.favRate<4 ) {
							 trigArray[0]["stringValue"].Value = "You know I'm not feeling well, give me a 12 hour break."; break;
						} else {
							 trigArray[0]["stringValue"].Value = "You are an energetic person. I'm happy too , but give me a 12 hour break."; break;
						}
				}
//Mask trigger
				var maskMomanSTr = trigArray[3]["receiverTargetName"].Value;
				trigArray[3]["receiverTargetName"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);

				executeTrigger.trigger.active = true;
				executeTrigger.trigger.active = false;

//Recover trigger
				trigArray[3]["receiverTargetName"].Value = maskMomanSTr;
				trigArray[0]["stringValue"].Value = "";
				executeTrigger.trigger.RestoreFromJSON(trigClass);

			} else {



			switch(Sd.favRate){

				case 0 :
					if(0 == UnityEngine.Random.Range(0, 2)){
						trigArray[0]["stringValue"].Value = "Don't come";
					} else {
							trigArray[0]["stringValue"].Value = "Leave me alone";
					}

					break ;
				case 1 :
					if(0 == UnityEngine.Random.Range(0, 2)){
						trigArray[0]["stringValue"].Value = "I feel much better. Why did you help me?";
					} else {
						trigArray[0]["stringValue"].Value = "Thank you. You've been very helpful.";
					}
					break ;
				case 2 :
					if(0 == UnityEngine.Random.Range(0, 2)){
						trigArray[0]["stringValue"].Value = "You're so sweet.";
					} else {
						trigArray[0]["stringValue"].Value = "You are gentle.";
					}
					break ;
				case 3 :
					if(0 == UnityEngine.Random.Range(0, 2)){
						trigArray[0]["stringValue"].Value = "Maybe I'm feeling fine. Do you like me?";
					} else {
						trigArray[0]["stringValue"].Value = "Maybe I'm feeling fine. Are you and I a good fit?";
					}
					break ;

				case 4 :
					if(0 == UnityEngine.Random.Range(0, 2)){
						trigArray[0]["stringValue"].Value = "I'm feeling fine. But I don't want to leave you.";
					} else {
						trigArray[0]["stringValue"].Value = "I'm feeling fine. I love you.";
					}
						break ;
				case 5 :
					if(0 == UnityEngine.Random.Range(0, 2)){
						trigArray[0]["stringValue"].Value = "All right. I'm already yours.";
					} else {
						trigArray[0]["stringValue"].Value = "All right. I'm so glad you came to see me. I love you.";
					}
					break ;

				default :
					switch(   Mathf.RoundToInt(UnityEngine.Random.Range(0f, 5f)) ){
						case 0: trigArray[0]["stringValue"].Value = "We've been together for " + new TimeSpan(0,Sd.totalPlaytime*2,0).ToString() +" now and it's still not enough."; break;
						case 1: trigArray[0]["stringValue"].Value = "I've been with you " + Sd.startCount + " times playing already and it's still not enough."; break;
						case 2: trigArray[0]["stringValue"].Value = "I've known you for " + timed.TotalDays + " days now, and my love for you hasn't changed."; break;
						case 3: trigArray[0]["stringValue"].Value = "You have made me orgasm up to " + Sd.maximumOrgasmCount + " times in one sex session, I love you."; break;
//						default : trigArray[0]["stringValue"].Value = "You have given me " + Sd.totalOrgasmCount + " orgasms so far. I'm so glad you did."; break;
						default : trigArray[0]["stringValue"].Value = "You have given me ."; break;
					}
					break ;
			}
//Mask trigger
			var maskMomanSTr = trigArray[3]["receiverTargetName"].Value;
			trigArray[3]["receiverTargetName"].Value = "";
			executeTrigger.trigger.RestoreFromJSON(trigClass);

			executeTrigger.trigger.active = true;
			executeTrigger.trigger.active = false;
			
//Recover trigger
			trigArray[3]["receiverTargetName"].Value = maskMomanSTr;
			trigArray[0]["stringValue"].Value = "";
			executeTrigger.trigger.RestoreFromJSON(trigClass);

			}


		}


		// Save
		void gameSave(){

			Sd.thisPlaytime ++;;	// time count

			if( ! FileManagerSecure.DirectoryExists(SavePath, true) ){
				FileManagerSecure.CreateDirectory(SavePath );
			}

			FileManagerSecure.WriteAllText(SavePath + SaveFile,JsonUtility.ToJson(Sd, true));

		} 

		// Load
		void gameLoad(){
			if( FileManagerSecure.FileExists(SavePath + SaveFile, true )){
				string val =  FileManagerSecure.ReadAllText(SavePath + SaveFile);
				Sd = JsonUtility.FromJson<SaveData>( val );
			} else {
				Sd.startCount = 0;
			}
		}
		
	    private class SaveData
    	{
       		public string id;
        	public int  startCount;
        	public int  favRate;

    	    public string FirstBoot;
    	    public string lastBoot;

    	    public int thisPlaytime;		// gameCount per 2min
			public int totalPlaytime;

			public int totalOrgasmCount;
			public int maximumOrgasmCount;
			public int thisOrgasmCount;

			public bool debugMode;

			public SaveData Clone() {
				return (SaveData) MemberwiseClone();
			}
	    }
	}
}
